;FASMLIB win32 version that compiles to DLL
;

format PE DLL

;code
section '.text' code readable executable

;FASMLIB settings
SYSTEM			equ win32      ;destination platform ("win32" or "linux")
INCLUDE_ALL_ERRORS	equ 1	       ;include unused errors too
INCLUDE_ALL_PROCS	equ 1	       ;include unused procedures too
INCLUDE_TIMEDATE	equ 1	       ;include string hodling time/date of compilation of FASMLIB
;HEAP_INIT_SIZE          equ 65536      ;default heap size, must be power of two (only valid when FASMLIB heap manager is used)
;HEAP_SIZE_ALIGN         equ 4096       ;aligning heap size, must be power of two (only valid when FASMLIB heap manager is used)
;HEAP_BLOCK_ALIGN        equ 64         ;aligning heap block size, must be power of two (only valid when FASMLIB heap manager is used)
DISPLAY_FASMLIB_INFO	equ 1	       ;display overall FASMLIB info during compilation
;DISPLAY_PROC_INFO       equ 0          ;display info about procedures during compilation, addresses must be fixed
DISPLAY_MODULE_INFO	equ 0	       ;display info about FASMLIB modules compilation
DISPLAY_STRUC_INFO	equ 0	       ;display info about FASMLIB structures compilation

;include FASMLIB
include '%FASMLIB%/include/fasm/fasmlib-src.inc'

;data
section '.data' data readable writeable
IncludeIData
IncludeUData

section '.idata' import data readable writeable
include '%FASMINC%\macro\import32.inc'

  library kernel,'KERNEL32.DLL',\
	  user,'USER32.DLL'

  import kernel,\
	 ExitProcess   ,'ExitProcess'	,\
	 CreateFileA   ,'CreateFileA'	,\
	 GetLastError  ,'GetLastError'	,\
	 CloseHandle   ,'CloseHandle'	,\
	 SetFilePointer,'SetFilePointer',\
	 ReadFile      ,'ReadFile'	,\
	 WriteFile     ,'WriteFile'	,\
	 GetProcessHeap,'GetProcessHeap',\
	 HeapAlloc     ,'HeapAlloc'	,\
	 HeapFree      ,'HeapFree'	,\
	 HeapReAlloc   ,'HeapReAlloc'	,\
	 VirtualAlloc  ,'HeapAlloc'	,\
	 VirtualFree   ,'HeapFree'	,\
	 VirtualReAlloc,'HeapReAlloc'	,\
	 GetStdHandle  ,'GetStdHandle'

section '.edata' export data readable
include '%FASMINC%\macro\export.inc'

exportlist equ 0
macro fasmlib_proc srcname*, libname*, argsize
{
   match _exportlist, exportlist
   \{
     define exportlist _exportlist, srcname, libname
   \}
}
DOT fix "_"
include 'proclist.inc'

match _exportlist, exportlist
{
  export _exportlist
}

section '.reloc' fixups data discardable

;by vid