;FASMLIB win32 version that compiles to ELF format

format ELF

;code
section '.text' executable align 16

;FASMLIB settings
SYSTEM			equ linux      ;destination platform ("win32" or "linux")
INCLUDE_ALL_ERRORS	equ 1	       ;include unused errors too
INCLUDE_ALL_PROCS	equ 1	       ;include unused procedures too
INCLUDE_TIMEDATE	equ 1	       ;include string hodling time/date of compilation of FASMLIB
HEAP_INIT_SIZE		equ 65536      ;default heap size, must be power of two (only valid when FASMLIB heap manager is used)
HEAP_SIZE_ALIGN 	equ 4096       ;aligning heap size, must be power of two (only valid when FASMLIB heap manager is used)
HEAP_BLOCK_ALIGN	equ 64	       ;aligning heap block size, must be power of two (only valid when FASMLIB heap manager is used)
DISPLAY_FASMLIB_INFO	equ 1	       ;display overall FASMLIB info during compilation
;DISPLAY_PROC_INFO       equ 0          ;display info about procedures during compilation, addresses must be fixed
DISPLAY_MODULE_INFO	equ 0	       ;display info about FASMLIB modules compilation
DISPLAY_STRUC_INFO	equ 0	       ;display info about FASMLIB structures compilation

;include FASMLIB
include '%FASMLIB%/include/fasm/fasmlib-src.inc'

;data
section '.data' writeable align 16
IncludeIData
IncludeUData

;FASMLIB procedures exports
macro fasmlib_proc srcname*, libname*, arglist
{
  public srcname as libname
}
DOT fix "."
include 'proclist.inc'