;FASMLIB win32 version that compiles to MS COFF format
;for use with FASM and NASM/YASM
;names are generated in form "stream.init"

format MS COFF

;code
section '.text' code readable executable align 16

;FASMLIB settings
SYSTEM			equ win32      ;destination platform ("win32" or "linux")
INCLUDE_ALL_ERRORS	equ 1	       ;include unused errors too
INCLUDE_ALL_PROCS	equ 1	       ;include unused procedures too
INCLUDE_TIMEDATE	equ 1	       ;include string hodling time/date of compilation of FASMLIB
;HEAP_INIT_SIZE          equ 65536      ;default heap size, must be power of two (only valid when FASMLIB heap manager is used)
;HEAP_SIZE_ALIGN         equ 4096       ;aligning heap size, must be power of two (only valid when FASMLIB heap manager is used)
;HEAP_BLOCK_ALIGN        equ 64         ;aligning heap block size, must be power of two (only valid when FASMLIB heap manager is used)
DISPLAY_FASMLIB_INFO	equ 1	       ;display overall FASMLIB info during compilation
;DISPLAY_PROC_INFO       equ 0          ;display info about procedures during compilation, addresses must be fixed
DISPLAY_MODULE_INFO	equ 0	       ;display info about FASMLIB modules compilation
DISPLAY_STRUC_INFO	equ 0	       ;display info about FASMLIB structures compilation

;include FASMLIB
include '%FASMLIB%/include/fasm/fasmlib-src.inc'

;data
section '.data' data readable writeable align 16
IncludeIData
IncludeUData

;FASMLIB procedures exports
macro  fasmlib_proc  srcname*, objname*, argsize
{
  public srcname as objname
}
DOT fix '.'
include 'proclist.inc'

;imports
macro import name, size {
  if used name
    extrn '__imp__'#`name#'@'#`size as name:dword
  end if
}

import ExitProcess, 4
import CreateFileA, 28
import GetLastError, 0
import CloseHandle, 4
import SetFilePointer, 16
import ReadFile, 20
import WriteFile, 20
import GetProcessHeap, 0
import HeapAlloc, 12
import HeapFree, 12
import HeapReAlloc, 16
import VirtualAlloc, 16
import VirtualFree, 12
import GetStdHandle, 4


;by vid