;demonstrates libcall macro
;portable part of code

BUFFER_SIZE = 80+1

udata {
  buffer  rb BUFFER_SIZE
}

start:
	;initialize modules
	libcall mem.init
	jc	error
	libcall stream.init
	jc	error

	;write prompt
	libcall text.write.format, stream.stdout, <"Please enter line of text (up to %d chars):",10>, BUFFER_SIZE-1
	jc	error

	;EBX = read one line of text
	libcall text.read.line, stream.stdin, buffer, BUFFER_SIZE
	jc	error

	;convert text char-by-char
	mov	esi, buffer
@@:	lodsb
	test	al, al
	je	@f
	libcall text.write.format, stream.stdout, "%02bx ", eax
	jc	error
	jmp	@b
@@:

	;write EOL
	libcall text.write, stream.stdout, _eol

	;uninitialize modules
	libcall stream.uninit
	jc	error
	libcall mem.uninit
	jc	error

	;end program with exit code 0
	libcall process.exit, 0



	;on error, EAX contains error code
error:
	;EBX = error message associated with error code in EAX
	libcall err.text, eax

	;write error message
	libcall text.write.format, stream.stderr, <10,"Error: %s!",10>, eax

	;unintialize modules
	libcall stream.uninit
	libcall mem.uninit

	;end program with exit code 1
	libcall process.exit, 1