;portable part of code


idata {
  ;word delimiter characters
  delims    db 9,10,13,' :,.',0
}

udata {
  ;buffer for file name
  MAX_FILENAME = 80+1
  filename  rb MAX_FILENAME
}

start:
	;initialize modules
	libcall mem.init
	jc	error
	libcall stream.init
	jc	error

	;write prompt
	libcall text.write.format, stream.stdout, <"Please enter name of file (max %d chars):",10>, MAX_FILENAME-1
	jc	error

	;read file name
	libcall text.read.line, stream.stdin, filename, MAX_FILENAME
	jc	error

	;EBX = open file
	libcall fstream.open, filename
	jc	error
	mov	ebx, eax

	;ECX = number of words
	xor	ecx, ecx

	;loop to skip words
next_word:

	;skip word delimiters
	libcall text.skip.chars, ebx, delims
	jc	error2

	;OF is returned if we are on EOF
	jo	done

	;skip all characters until EOF or next delimiter
	libcall text.skip.until, ebx, delims
	jc	error2

	;OF is returned if we are on EOF
	jo	done

	;another word done
	inc	ecx
	jmp	next_word

done:

	;close file
	libcall stream.close, ebx
	jc	error

	;print result
	libcall text.write.format, stream.stdout, <"File %s contains %d words",10>, filename, ecx
	jc	error


	;uninitialize modules
	libcall stream.uninit
	jc	error
	libcall mem.uninit
	jc	error

	;end program with exit code 0
	libcall process.exit, 0



	;error, but we must also close file
error2:
	push	eax
	libcall stream.close, ebx
	pop	eax

	;on error, EAX contains error code
error:
	;write error message
	libcall err.text, eax
	libcall text.write.format, stream.stderr, <10,"Error: %s!",10>, eax


	;unintialize modules
	libcall stream.uninit
	libcall mem.uninit

	;end program with exit code 1
	libcall process.exit, 1