;dec2hex example of FASMLIB usage from FASM
;includes FASMLIB directly by source

;compile with:
;  fasm dec2hex.asm

format PE

SYSTEM equ win32
include "%fasminc%/win32ax.inc"
include "%fasmlib%/include/fasm/fasmlib-src.inc"

.code

start:
	;initialize modules
	call	mem.init
	jc	error
	call	stream.init
	jc	error

	;write prompt
	push	_example
	push	stream.stdout
	call	text.write
	jc	error

	;read decimal number
	push	stream.stdin
	call	text.read.dec2d
	jc	error

	;write it as hex number
	push	eax
	push	_hex_format
	push	stream.stdout
	call	text.write.format
	jc	error

	;uninitialize modules
	call	stream.uninit
	jc	error
	call	mem.uninit
	jc	error

	;end program with exit code 0
	push	0
	call	process.exit



	;on error, EAX contains error code
error:
	;EBX = error message associated with error code in EAX
	push	eax
	call	err.text

	;write error message
	push	eax
	push	_err_format
	push	stream.stderr
	call	text.write.format

	;unintialize modules
	call	stream.uninit
	call	mem.uninit

	;end program with exit code 1
	push	1
	call	process.exit

.data
	_example	db "Example of FASMLIB usage in FASM ", 10
			db "Please type decimal dword value: ",0

	_hex_format	db "It's 0x%h",0

	_err_format	db 10, "Error: %s!",10,0

	IncludeIData
	IncludeUData

.end start