; dec2hex example of FASMLIB usage in MASM

; compile with:
;       ml /c /coff dec2hex.asm
; link with:
;       link /subsystem:console wc.obj "%FASMLIB%/bin/mscoff2.obj" kernel32.lib


; #########################################################################

      .586
      .model flat, stdcall
      option casemap:none    ; case sensitive

; #########################################################################

      %include @Environ(FASMLIB)\\include\\masm\\fasmlib.inc

; #########################################################################
  .data
	;your data here
	_prompt 	db "Example of FASMLIB usage in MASM ", 10
			db "Please type decimal dword value: ",0

	_hex		db "It's 0x",0

	_err_format	db 10, "Error: %s!",10,0

; #########################################################################

    .code

start:
	;initialize modules
	invoke	mem_init
	jc	error
	invoke	stream_init
	jc	error

	;write prompt
	invoke	text_write, stream_stdout, offset _prompt
	jc	error

	;EBX = read decimal number
	invoke	text_read_dec2d, stream_stdin
	jc	error
	mov	ebx, eax

	;write notice
	invoke	text_write, stream_stdout, offset _hex
	jc	error

	;write EBX as hex number
	invoke	text_write_d2hex, stream_stdout, ebx
	jc	error

	;uninitialize modules
	invoke	stream_uninit
	jc	error
	invoke	mem_uninit
	jc	error

	;end program with exit code 0
	invoke	process_exit, 0



	;on error, EAX contains error code
error:
	;EAX = error message associated with error code in EAX
	invoke	err_text, eax

	;display error message
	push	eax
	invoke	text_write_format, stream_stderr, offset _err_format

	;unintialize modules
	invoke	stream_uninit
	invoke	mem_uninit

	;end program with exit code 1
	invoke	process_exit, 1

end start