;FASMLIB Hello World example in NASM/YASM for win32

;win32:
;compile with:
;  nasm -f win32 hello.asm
;link with: (with MS link and MS Visual C/C++ libcmt.lib)
;  link /subsystem:console /entry:start hello.obj libcmt.lib "%FASMLIB%\bin\mscoff.obj" kernel32.lib


%include "%!FASMLIB/include/nasm/fasmlib.inc"
global _start
[section .text]
_start:
	;initialize FASMLIB
	call	mem.init
	jc	error
	call	stream.init
	jc	error

	;display string
	push	_hello
	push	stream.stdout
	call	text.write
	jc	error

	;uninitialize FASMLIB
	call	stream.uninit
	jc	error
	call	mem.uninit
	jc	error

	;exit with code 0
	push	0
	call	process.exit

;error handler
error:
	;get error message
	push	eax
	call	err.text

	;display error message
	push	eax
	push	_err_format
	push	stream.stderr
	call	text.write.format

	;uninitialize FASMLIB
	call	stream.uninit
	call	mem.uninit

	;exit with code 1
	push	1
	call	process.exit

[section .data]
_hello		db "Hell o' World",10,0
_err_format	db 10,"Error: %s",10,0