macro include_module name, path {
  local ..code_start, ..code_size, ..data_start, ..data_size

  match =1, DISPLAY_MODULE_INFO \{
    display 13,10,'Module "'#`name#'": ',13,10	;TODO   EOLs
  \}

  ;save starting addresses
  ..code_start:
  idata \{
    ..data_size = $-..data_start
  \}

  ;include file
  include path

  ;save sizes
  ..code_size = $-..code_start
  idata \{
    ..data_start:
  \}

  match =1, DISPLAY_MODULE_INFO \{
    disphex 'size of code: ', $-..code_start
    disphex 'size of data: ', ..data_size
  \}

  match =1, DISPLAY_FASMLIB_INFO \{
    total_fasmlib_code = total_fasmlib_code + ..code_size
    total_fasmlib_data = total_fasmlib_data + ..data_size
  \}

}

match =1, DISPLAY_FASMLIB_INFO {
  total_fasmlib_code = 0
  total_fasmlib_data = 0
}

include '../../src/fasmlib.inc'
include_module mem,	'../../src/mem.inc'
include_module file,	'../../src/file.inc'
include_module conv,	'../../src/conv.inc'
include_module str,	'../../src/str.inc'
include_module process, '../../src/process.inc'
include_module stream,	'../../src/stream.inc'
include_module text,	'../../src/text.inc'
include_module fstream, '../../src/fstream.inc'
include_module memstream, '../../src/mstream.inc'

match =1, DISPLAY_FASMLIB_INFO {
    disphex 'size of FASMLIB code: ', total_fasmlib_code
    disphex 'size of FASMLIB data: ', total_fasmlib_data
}

match =1, INCLUDE_TIMEDATE {
  gettimedate
  idata \{
    db "FASMLIB v", FASMLIB_VERSION_STRING, " compiled at ", DATE, 0
  \}
}

purge include_module