;FASMLIB includes for NASM and YASM
;can be used for MS-COFF and ELF versions

%define FASMLIB_VERSION_STRING	"0.5.0"
%define FASMLIB_VERSION_MAJOR	 0
%define FASMLIB_VERSION_MINOR	 5
%define FASMLIB_VERSION_REVISION 0

;-----------------------------------------------------------------------------
; procedures

;fasmlib
extern err.text

;process
extern process.exit

;file
extern file.open
extern file.create
extern file.seek
extern file.read
extern file.write
extern file.close

;mem
extern mem.init
extern mem.uninit
extern mem.alloc
extern mem.alloc0
extern mem.free
extern mem.realloc
extern mem.realloc0
extern mem.size
extern mem.fill
extern mem.copy
extern mem.cmp
extern mem.find

;str
extern str.copy
extern str.cat
extern str.catchar
extern str.ins
extern str.inschar
extern str.sub
extern str.lowcase
extern str.upcase
extern str.len
extern str.cmp
extern str.cmpi
extern str.pos
extern str.poschar

;stream
extern stream.stdout
extern stream.stdin
extern stream.stderr
extern stream.init
extern stream.uninit
extern stream.create
extern stream.write
extern stream.writechar
extern stream.read
extern stream.readchar
extern stream.readnb
extern stream.peek
extern stream.peekchar
extern stream.peeknb
extern stream.skip
extern stream.close

;file stream
extern fstream.open
extern fstream.extopen
extern fstream.create
extern fstream.extcreate

;memory stream
extern memstream.openr
extern memstream.extopenr
extern memstream.openw
extern memstream.extopenw

;conv
extern conv.b2hex
extern conv.w2hex
extern conv.d2hex
extern conv.b2dec
extern conv.w2dec
extern conv.d2dec
extern conv.ib2hex
extern conv.iw2hex
extern conv.id2hex
extern conv.ib2dec
extern conv.iw2dec
extern conv.id2dec
extern conv.hex2b
extern conv.hex2w
extern conv.hex2d
extern conv.dec2b
extern conv.dec2w
extern conv.dec2d
extern extconv.b2hex
extern extconv.w2hex
extern extconv.d2hex
extern extconv.b2dec
extern extconv.w2dec
extern extconv.d2dec
extern extconv.ib2hex
extern extconv.iw2hex
extern extconv.id2hex
extern extconv.ib2dec
extern extconv.iw2dec
extern extconv.id2dec
extern extconv.hex2b
extern extconv.hex2w
extern extconv.hex2d
extern extconv.dec2b
extern extconv.dec2w
extern extconv.dec2d

;text
extern text.write
extern text.write.str
extern text.write.format
extern text.write.b2hex
extern text.write.w2hex
extern text.write.d2hex
extern text.write.b2dec
extern text.write.w2dec
extern text.write.d2dec
extern text.read.char
extern text.read.chars
extern text.read.until
extern text.read.line
extern text.read.hex2b
extern text.read.hex2w
extern text.read.hex2d
extern text.read.dec2b
extern text.read.dec2w
extern text.read.dec2d
extern text.fetch
extern text.fetch.str
extern text.fetch.char
extern text.skip.chars
extern text.skip.until
extern text.skip.dec
extern text.skip.hex
extern text.extwrite.b2hex
extern text.extwrite.w2hex
extern text.extwrite.d2hex
extern text.extwrite.b2dec
extern text.extwrite.w2dec
extern text.extwrite.d2dec
extern text.extread.chars
extern text.extread.until
extern text.extread.line
extern text.extread.hex2b
extern text.extread.hex2w
extern text.extread.hex2d
extern text.extread.dec2b
extern text.extread.dec2w
extern text.extread.dec2d
extern text.extskip.chars
extern text.extskip.until
extern text.extskip.dec
extern text.extskip.hex

;-----------------------------------------------------------------------------
; errcode macro

;TODO

;-----------------------------------------------------------------------------
; FASMLIB error codes
%define ERR_FASMLIB			00h ; "Internal FASMLIB assertion failed. This is bug in FASMLIB. Please report!"
%define ERR_UNKNOWN			01h ; "Unknown error"
%define ERR_MODULE_NOT_INITIALIZED	02h ; "(internal) Module not initialized"
%define ERR_OUT_OF_MEM			03h ; "Out of memory"
%define ERR_NOT_HEXADECIMAL		04h ; "Awaiting hexadecimal value"
%define ERR_NOT_DECIMAL 		05h ; "Awaiting decimal value"
%define ERR_NOT_FLOAT			06h ; "Awaiting floating point value"
%define ERR_NOT_BLANK			07h ; "Awaiting blank space"
%define ERR_OUT_OF_RANGE		08h ; "Out of range"
%define ERR_ZERO_SIZE			09h ; "(internal) Zero size"
%define ERR_ZERO_VALUE			0Ah ; "(internal) Zero value"
%define ERR_BUFFER_FULL 		0Bh ; "(internal) Insufficent buffer space"
%define ERR_INVALID_MODE		0Ch ; "(internal) Invalid mode"
%define ERR_INVALID_HANDLE		0Dh ; "(internal) Invalid handle"
%define ERR_HANDLE_NOT_WRITEABLE	0Eh ; "(internal) Handle not writeable"
%define ERR_HANDLE_NOT_READABLE 	0Fh ; "(internal) Handle not readable"
%define ERR_HANDLE_NOT_CLOSEABLE	10h ; "(internal) Handle not closeable"
%define ERR_HANDLE_NO_BUFFER		11h ; "(internal) Handle doesn't have buffer associated"
%define ERR_HANDLE_CORRUPT		12h ; "(internal) Handle is corrupt"
%define ERR_HANDLE_EOF			13h ; "End of file reached"
%define ERR_FILE_EXISTS 		14h ; "File already exists"
%define ERR_FILE_NOT_FOUND		15h ; "File not found"
%define ERR_CANT_OPEN_FILE		16h ; "Can't open file"

;-----------------------------------------------------------------------------
; data macros

;TODO

;-----------------------------------------------------------------------------
; libcall macro

;TODO
