;FASM STANDARD LIBRARY
;Basic data definition macros

macro idata arg
{
  __IData equ __IData,	 ;add one ',' to __IData, initial "__IData" before ','s will be used to call macro
  macro __IDataBlock	 ;begin macro (or overload old one) which holds data inside "idata" block
  arg
}

macro udata arg
{
  __UData equ __UData,
  macro __UDataBlock
  arg
}

;include all "idata"-defined blocks
macro IncludeIData
{
  macro __IData dummy,[n]  ;create macro which will be invoked, [n] makes sure macro's forward will
  \{			   ;be preprocessed for each ',' added to __IData
    \forward
       align 4
       __IDataBlock	   ;use the macro with data
       purge __IDataBlock  ;and remove it so previous macro becomes avilable
  \}
  match I, __IData \{ I \} ;and now unroll __IData macro (just "__IData" wouldn't do, replaced equate isn't
			   ;preprocessed anymore and so it wouldn't beheave as macro usage)
  purge __IData 	   ;__Idata macro is not needed anymore
}


;include all "udata"-defined blocks
macro IncludeUData	   ;... same as IncludeIData but it is whole in virtual to count size and define labels
{			   ;and then required space is reserved
  macro __UData dummy,[n]
  \{
    \common
       \local ..begin, ..size
       ..begin = $
       virtual at $
    \forward
       align 4
       __UDataBlock
       purge __UDataBlock
    \common
       ..size = $ - ..begin
       end virtual
       rb ..size
   \}
  match U, __UData
  \{
    U
  \}
  purge __UData
}

;use both macros at least once
idata{
 _eol db 10,0
}
udata{}